/**
 *
 */
export class RecordState {
    constructor(value) {
        if (typeof value === 'string') {
            this._value = JSON.parse(value);
        }
        else {
            this._value = value;
        }
    }
    // --- State Management Helpers --- //
    static getPropertyValue(record, propertyName) {
        return (new RecordState(record)).getPropertyValue(propertyName);
    }
    static setPropertyValue(record, propertyName, value) {
        return (new RecordState(record)).setPropertyValue(propertyName, value);
    }
    // --- State Import/Export --- //
    copyAsJsonObject() {
        return JSON.parse(this.copyAsJsonString());
    }
    copyAsJsonString() {
        return JSON.stringify(this.internalValue());
    }
    internalValue() {
        return this._value;
    }
    // --- State Management --- //
    getPropertyValue(propertyName) {
        for (const p of this.internalValue().properties) {
            if (p.name === propertyName) {
                return p.value;
            }
        }
        return undefined;
    }
    setPropertyValue(propertyName, value) {
        for (const p of this.internalValue().properties) {
            if (p.name === propertyName) {
                p.value = value;
                return true;
            }
        }
        return false;
    }
}
