import { BlobClientResponse } from "../client/BlobClientResponse";
import { Client } from "../client/Client";
import { JsonClientResponse } from "../client/JsonClientResponse";
import { TextClientResponse } from "../client/TextClientResponse";
import { VoidClientResponse } from "../client/VoidClientResponse";
import { StreamProducer } from '../io';
import { StringDictionary } from '../util/StringDictionary';
export declare class DialogProxy implements Client {
    private _dialogDelegateChain;
    private _lastActivity;
    private _initialized;
    constructor();
    readonly lastActivity: Date;
    getBlob(baseUrl: string, resourcePath?: string): Promise<BlobClientResponse>;
    getText(baseUrl: string, resourcePath?: string): Promise<TextClientResponse>;
    openStream(baseUrl: string, resourcePath?: string): Promise<StreamProducer>;
    postMultipart(baseUrl: string, resourcePath: string, formData: FormData): Promise<VoidClientResponse>;
    getJson(baseUrl: string, resourcePath?: string, queryParams?: StringDictionary): Promise<JsonClientResponse>;
    postJson(baseUrl: string, resourcePath: string, jsonBody?: StringDictionary): Promise<JsonClientResponse>;
    putJson(baseUrl: string, resourcePath: string, jsonBody?: StringDictionary): Promise<JsonClientResponse>;
    deleteJson(baseUrl: string, resourcePath: string): Promise<JsonClientResponse>;
    private prepareForActivity();
}
